=== debian/changelog ===
libchewing (0.10.3-1) unstable; urgency=medium

  * New upstream version 0.10.3

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 24 Aug 2025 20:14:33 +0800
