## libchewing 0.11.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.24.0...3.31.6)
 project(libchewing LANGUAGES C)
 
-set(CMAKE_PROJECT_VERSION 0.10.3)
+set(CMAKE_PROJECT_VERSION 0.11.0)
 
 find_package(Git)
 if(Git_FOUND)
@@ -37,6 +37,9 @@
 include(FetchContent)
 
 option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
+option(USE_SYSTEM_CHEWING_CLI "Use system-installed chewing-cli to build dictionary" OFF)
+option(BUILD_DOC "Build documentation" ON)
+option(BUILD_DATA "Build chewing dictionaries" ON)
 
 if(CMAKE_C_COMPILER_ID MATCHES GNU|Clang)
     set(CMAKE_C_FLAGS "-std=gnu99 -finput-charset=utf-8 ${CMAKE_C_FLAGS}")
@@ -71,12 +74,17 @@
 endif()
 
 corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing_capi)
-corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing_testhelper)
+if(BUILD_TESTING)
+    corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing_testhelper)
+endif()
 corrosion_import_crate(MANIFEST_PATH Cargo.toml CRATES chewing-cli)
 
 if(WITH_SQLITE3)
     corrosion_set_features(chewing_capi FEATURES sqlite)
-    corrosion_set_features(chewing_testhelper FEATURES sqlite)
+    if(BUILD_TESTING)
+        corrosion_set_features(chewing_testhelper FEATURES sqlite)
+    endif()
+    corrosion_set_features(chewing-cli FEATURES sqlite)
 endif()
 
 if(ENABLE_GCOV)
@@ -87,7 +95,9 @@
 if(CMAKE_SYSTEM MATCHES "Windows")
     set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded")
     corrosion_add_target_rustflags(chewing_capi -Ctarget-feature=+crt-static)
-    corrosion_add_target_rustflags(chewing_testhelper -Ctarget-feature=+crt-static)
+    if(BUILD_TESTING)
+        corrosion_add_target_rustflags(chewing_testhelper -Ctarget-feature=+crt-static)
+    endif()
     corrosion_add_target_rustflags(chewing-cli -Ctarget-feature=+crt-static)
     if(VCPKG_TARGET_TRIPLET)
         corrosion_set_env_vars(chewing-cli VCPKGRS_TRIPLET=${VCPKG_TARGET_TRIPLET})
@@ -113,8 +123,6 @@
 set(INC_DIR ${PROJECT_SOURCE_DIR}/capi/include)
 set(TOOLS_SRC_DIR ${PROJECT_SOURCE_DIR}/src/tools)
 set(TOOLS_BIN_DIR ${PROJECT_BINARY_DIR}/src/tools)
-set(DATA_SRC_DIR ${PROJECT_SOURCE_DIR}/data)
-set(DATA_BIN_DIR ${PROJECT_BINARY_DIR}/data)
 set(TEST_SRC_DIR ${PROJECT_SOURCE_DIR}/tests)
 set(TEST_BIN_DIR ${PROJECT_BINARY_DIR}/tests)
 
@@ -158,17 +166,24 @@
     ${INC_DIR}/mod_aux.h
 )
 
-add_subdirectory(doc)
-add_subdirectory(data)
+if(NOT USE_SYSTEM_CHEWING_CLI)
+    set(CHEWING_CLI $<TARGET_FILE:chewing-cli>)
+endif()
+
+if(BUILD_DOC)
+    add_subdirectory(doc)
+endif()
+
+if(BUILD_DATA)
+    add_subdirectory(data)
+endif()
+
 if(BUILD_TESTING)
     add_subdirectory(tests)
 endif()
 
 add_library(libchewing ${ALL_INC} capi/src/chewing.c)
 set_target_properties(libchewing PROPERTIES LINKER_LANGUAGE C)
-target_compile_definitions(libchewing PRIVATE
-    CHEWING_DATADIR=\"${CMAKE_INSTALL_FULL_DATADIR}/libchewing\"
-)
 target_include_directories(libchewing
     PUBLIC
         $<BUILD_INTERFACE:${INC_DIR}>
@@ -233,6 +248,19 @@
     INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
     LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
+
+if(BUILD_DATA)
+    install(
+        FILES
+            ${PROJECT_BINARY_DIR}/data/dict/chewing/tsi.dat
+            ${PROJECT_BINARY_DIR}/data/dict/chewing/word.dat
+            ${PROJECT_BINARY_DIR}/data/misc/swkb.dat
+            ${PROJECT_BINARY_DIR}/data/misc/symbols.dat
+        DESTINATION
+            ${CMAKE_INSTALL_DATADIR}/libchewing
+    )
+endif()
+
 install(IMPORTED_RUNTIME_ARTIFACTS chewing-cli DESTINATION ${CMAKE_INSTALL_BINDIR})
 
 # generate CMake Config files
