=== debian/changelog ===
libchewing (0.11.0-1) unstable; urgency=medium

  * New upstream version 0.11.0.
  * d/control: Update Build-Depends.
  * d/symbols: Update symbols for 0.11.0
    * Add Build-Depends-Packages.
  * d/control: Bump Standards-Version to 4.7.3:
    * Remove unnecessary Priority, Rules-Required-Root.
  * d/patches: Remove patch to remove clap_mangen.
  * d/patches: Update dependencies to prevent using sqlite-bundled.
  * d/upstream: Minimal upstream signing key.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 11 Jan 2026 12:08:42 +0800

libchewing (0.10.3-2) unstable; urgency=medium

  [ Peter Michael Green ]
  * Drop unneeded build-dependency for directories crate. (Closes: #1123998)

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 28 Dec 2025 01:26:06 +0800
