=== debian/watch ===
Version: 5
Template: GitHub
Owner: chewing
Project: libchewing
Download-Url-Mangle: s%https://api.github.com/repos/([^/]+)/@PACKAGE@/git/refs/tags/@ANY_VERSION@%https://github.com/$1/@PACKAGE@/releases/download/v$2/@PACKAGE@-$2.tar.zst%g
Pgp-Mode: auto
